//// Ejercicio 6-4 ////
////---------------////
clear;
clc;
// Parámetros del sistema graficador//
La=0.003;      // Inductancia de armadura del motor DC [H]
Ra=0.48;       // Resistencia de armadura del motor DC [Ohms]
Kt=0.68;       // Constante de Torque del motor DC [Nm/A]
Kw=0.68;       // Constante de Generación del motor DC [Vs/rad]
J=0.03;        // Momento de incercia sobre el eje del motor [Nms2]
B=0.0011;      // Rozamiento sobre el eje del motor [Nms/rad]
rN=0.1;        // Relación caja reductora y radio polea [m/rad]

// Cálculo de las matrices del modelo de estados continuo//
A = [-Ra/La -Kw/La 0;
     Kt/J   -B/J   0;
     0       rN    0];
B = [1/La;0;0];
C = [0 0 1];
D = 0;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Modelo de estado discreto ----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

// Cálculo matriz de transicion de estados
s = poly(0,"s");            // Variable de Laplace
I_2 = eye(3,3);             // Matriz identidad de 2x2
sia = s*I_2-A              // sI-A
adj_sia = coffg(sia);       // Adj(sI-A)
det_sia = det(sia);         // Det(sI-A)
inv_sia = adj_sia/det_sia;  // (sI-A)^-1

// Descomposición en fracciones parciales

// Elemento 1,1
T11=pfss(inv_sia(1,1))
// Elemento 1,2
T12=pfss(inv_sia(1,2))
// Elemento 1,3
T13=pfss(inv_sia(1,3))
// Elemento 2,1
T21=pfss(inv_sia(2,1))
// Elemento 2,2
T22=pfss(inv_sia(2,2))
// Elemento 2,3
T23=pfss(inv_sia(2,3))
// Elemento 3,1
T31=pfss(inv_sia(3,1))
// Elemento 3,2
T32=pfss(inv_sia(3,2))
// Elemento 3,3
T33=pfss(inv_sia(3,3))


//-------------------------------------------------------
// Calculo elementos de Ad
//-------------------------------------------------------

Ts=0.001; //Periodo de muestreo

// -------- Elemento Ad11 --------------
P1=roots(T11(2).den);
res1=T11(2).num;
P2=roots(T11(1).den);
res2=T11(1).num;
Ad11=res1*exp(P1*Ts)+res2*exp(P2*Ts);

// -------- Elemento Ad12 --------------
P1=roots(T12(2).den);
res1=T12(2).num;
P2=roots(T12(1).den);
res2=T12(1).num;
Ad12=res1*exp(P1*Ts)+res2*exp(P2*Ts)

// -------- Elemento Ad13 --------------
Ad13=0;

// -------- Elemento Ad21 --------------
P1=roots(T21(2).den);
res1=T21(2).num;
P2=roots(T21(1).den);
res2=T21(1).num;
Ad21=res1*exp(P1*Ts)+res2*exp(P2*Ts);

// -------- Elemento Ad22 --------------
P1=roots(T22(2).den);
res1=T22(2).num;
P2=roots(T22(1).den);
res2=T22(1).num;
Ad22=res1*exp(P1*Ts)+res2*exp(P2*Ts);

// -------- Elemento Ad23 --------------
Ad23=0;

// -------- Elemento Ad31 --------------
P1=roots(T31(2).den);
res1=T31(2).num;
P2=roots(T31(1).den);
res2=T31(1).num;
P3=roots(T31(3).den);
res3=T31(3).num;
Ad31=res1*exp(P1*Ts)+res2*exp(P2*Ts)+res3*exp(P3*Ts);

// -------- Elemento Ad32 --------------
P1=roots(T32(2).den);
res1=T32(2).num;
P2=roots(T32(1).den);
res2=T32(1).num;
P3=roots(T32(3).den);
res3=T32(3).num;
Ad32=res1*exp(P1*Ts)+res2*exp(P2*Ts)+res3*exp(P3*Ts);

// -------- Elemento Ad32 --------------
P1=roots(T33(1).den);
res1=T33(1).num;
Ad33=res1*exp(P1*Ts);

Adx=[Ad11 Ad12 Ad13; Ad21 Ad22 Ad23; Ad31 Ad32 Ad33]



//-------------------------------------------------------
// Calculo elementos de Bd
//-------------------------------------------------------

TB=inv_sia*B
TB11=pfss(TB(1,1))
TB21=pfss(TB(2,1))
TB31=pfss(TB(3,1))


// -------- Elemento Bd11 --------------
P1=roots(TB11(1).den);
P2=roots(TB11(2).den);
res1=TB11(1).num;
res2=TB11(2).num;

Bd11=(res1/P1)*exp(P1*Ts)+(res2/P2)*exp(P2*Ts)-((res1/P1)+(res2/P2));

// -------- Elemento Bd21 --------------
P1=roots(TB21(1).den);
P2=roots(TB21(2).den);
res1=TB21(1).num;
res2=TB21(2).num;

Bd21=(res1/P1)*exp(P1*Ts)+(res2/P2)*exp(P2*Ts)-((res1/P1)+(res2/P2));

// -------- Elemento Bd31 --------------
P1=roots(TB31(1).den);
P2=roots(TB31(2).den);
P3=roots(TB31(3).den);
res1=TB31(1).num;
res2=TB31(2).num;
res3=TB31(3).num;

Bd31=res1*Ts+(res2/P2)*exp(P2*Ts)+(res3/P3)*exp(P3*Ts)-(0+(res2/P2)+(res3/P3));

Bdx=[Bd11;Bd21;Bd31]

// El modelo se completa

Cdx=C;
Ddx=D;

//---------------------------------------------------------------
// Con Scilab el pasaje el modelo continuo a discreto es directo
Gp=syslin('c',A,B,C,D);
Gpd=dscr(Gp,Ts);
[Ad,Bd,Cd,Dd]=abcd(Gpd);

// Comparativa
// Matriz A discreta
Ad
Adx
// Matriz B discreta
Bd
Bdx


